(function(){suite("djblets/gravy/backboneUtils",function(){var e;beforeEach(function(){e=new Backbone.Model}),describe("$.fn.bindClass",function(){var t;beforeEach(function(){t=$("<div/>").appendTo(document.body)}),describe("Initial class value",function(){it("Adds class when true",function(){e.set("mybool",!0),t.bindClass(e,"mybool","myclass"),expect(t.hasClass("myclass")).toBe(!0)}),it("No class when false",function(){e.set("mybool",!1),t.bindClass(e,"mybool","myclass"),expect(t.hasClass("myclass")).toBe(!1)}),describe("With inverse",function(){it("No class when true",function(){e.set("mybool",!0),t.bindClass(e,"mybool","myclass",{inverse:!0}),expect(t.hasClass("myclass")).toBe(!1)}),it("Adds class when false",function(){e.set("mybool",!1),t.bindClass(e,"mybool","myclass",{inverse:!0}),expect(t.hasClass("myclass")).toBe(!0)})})}),describe("Model property changes",function(){it("Removes class when true -> false",function(){e.set("mybool",!0),t.bindClass(e,"mybool","myclass"),e.set("mybool",!1),expect(t.hasClass("myclass")).toBe(!1)}),it("Adds class when false -> true",function(){e.set("mybool",!1),t.bindClass(e,"mybool","myclass"),e.set("mybool",!0),expect(t.hasClass("myclass")).toBe(!0)}),describe("With inverse",function(){it("Adds class when true -> false",function(){e.set("mybool",!0),t.bindClass(e,"mybool","myclass",{inverse:!0}),e.set("mybool",!1),expect(t.hasClass("myclass")).toBe(!0)}),it("Removes class when false -> true",function(){e.set("mybool",!1),t.bindClass(e,"mybool","myclass",{inverse:!0}),e.set("mybool",!0),expect(t.hasClass("myclass")).toBe(!1)})})})}),describe("$.fn.bindProperty",function(){var t,n,r;beforeEach(function(){t=$("<input type='checkbox'/>").appendTo(document.body),n=$('<input type="radio" name="my-radio" value="one" />').appendTo(document.body),r=$('<input type="radio" name="my-radio" value="two" />').appendTo(document.body)}),afterEach(function(){t.remove(),n.remove(),r.remove()}),describe("Initial property values",function(){it("Setting element's property from model property's",function(){e.set("mybool",!0),t.bindProperty("checked",e,"mybool"),expect(t.prop("checked")).toBe(!0)}),it("Setting element's property from model property's with inverse=true",function(){e.set("mybool",!1),t.bindProperty("checked",e,"mybool",{inverse:!0}),expect(t.prop("checked")).toBe(!0),expect(e.get("mybool")).toBe(!1)}),it("Setting element's property from model property with radioValue",function(){e.set("myvalue","one"),n.bindProperty("checked",e,"myvalue",{radioValue:"one"}),r.bindProperty("checked",e,"myvalue",{radioValue:"two"}),expect(n.prop("checked")).toBe(!0),expect(r.prop("checked")).toBe(!1),expect(e.get("myvalue")).toBe("one")}),it("No element changes with modelToElement=false",function(){e.set("mybool",!0),t.bindProperty("checked",e,"mybool",{modelToElement:!1}),expect(t.prop("checked")).toBe(!1)})}),describe("Model property changes",function(){it("Setting element's property",function(){e.set("mybool",!1),t.bindProperty("checked",e,"mybool"),expect(t.prop("checked")).toBe(!1),e.set("mybool",!0),expect(t.prop("checked")).toBe(!0)}),it("Setting element's property with inverse=true",function(){e.set("mybool",!1),t.bindProperty("checked",e,"mybool",{inverse:!0}),expect(t.prop("checked")).toBe(!0),e.set("mybool",!0),expect(t.prop("checked")).toBe(!1),expect(e.get("mybool")).toBe(!0)}),it("Setting element's property with radioValue",function(){e.set("myvalue","one"),n.bindProperty("checked",e,"myvalue",{radioValue:"one"}),r.bindProperty("checked",e,"myvalue",{radioValue:"two"}),expect(n.prop("checked")).toBe(!0),expect(r.prop("checked")).toBe(!1),e.set("myvalue","two"),expect(n.prop("checked")).toBe(!1),expect(r.prop("checked")).toBe(!0),expect(e.get("myvalue")).toBe("two")}),it("No element changes with modelToElement=false",function(){e.set("mybool",!1),t.bindProperty("checked",e,"mybool",{modelToElement:!1}),e.set("mybool",!0),expect(t.prop("checked")).toBe(!1)})}),describe("Element property changes",function(){it("Setting model's property",function(){e.set("mybool",!1),t.bindProperty("checked",e,"mybool"),t.click(),expect(t.prop("checked")).toBe(!0),expect(e.get("mybool")).toBe(!0)}),it("Setting model's property with inverse=true",function(){e.set("mybool",!1),t.bindProperty("checked",e,"mybool",{inverse:!0}),t.prop("checked",!1),t.click(),expect(t.prop("checked")).toBe(!0),expect(e.get("mybool")).toBe(!1)}),it("Setting model's property with radioValue",function(){e.set("myvalue","one"),n.bindProperty("checked",e,"myvalue",{radioValue:"one"}),r.bindProperty("checked",e,"myvalue",{radioValue:"two"}),r.click(),expect(n.prop("checked")).toBe(!1),expect(r.prop("checked")).toBe(!0),expect(e.get("myvalue")).toBe("two")}),it("No model changes with elementToModel=false",function(){e.set("mybool",!1),t.bindProperty("checked",e,"mybool",{elementToModel:!1}),t.click(),expect(t.prop("checked")).toBe(!0),expect(e.get("mybool")).toBe(!1)})}),describe("Special properties",function(){it("text",function(){var t=$("<p/>");t.bindProperty("text",e,"text",{elementToModel:!1}),e.set("text","hello world!"),expect(t.text()).toBe("hello world!")}),it("html",function(){var t=$("<p/>");t.bindProperty("html",e,"html",{elementToModel:!1}),e.set("html","<b>hello world!</b>"),expect(t.html()).toBe("<b>hello world!</b>")})})}),describe("$.fn.bindVisibility",function(){var t;beforeEach(function(){t=$("<div/>").appendTo(document.body)}),afterEach(function(){t.remove()}),describe("Showing elements",function(){it("When property is initially true",function(){t.hide(),e.set("mybool",!0),t.bindVisibility(e,"mybool"),expect(t.is(":visible")).toBe(!0)}),it("When property is initially false with inverse=true",function(){t.hide(),e.set("mybool",!1),t.bindVisibility(e,"mybool",{inverse:!0}),expect(t.is(":visible")).toBe(!0)}),it("When property is changed to true",function(){expect(t.is(":visible")).toBe(!0),e.set("mybool",!1),t.bindVisibility(e,"mybool"),e.set("mybool",!0),expect(t.is(":visible")).toBe(!0)}),it("When property is changed to false with inverse=true",function(){t.hide(),e.set("mybool",!0),t.bindVisibility(e,"mybool",{inverse:!0}),e.set("mybool",!1),expect(t.is(":visible")).toBe(!0)})}),describe("Hiding elements",function(){it("When property is initially false",function(){expect(t.is(":visible")).toBe(!0),e.set("mybool",!1),t.bindVisibility(e,"mybool"),expect(t.is(":visible")).toBe(!1)}),it("When property is initially true with inverse=true",function(){expect(t.is(":visible")).toBe(!0),e.set("mybool",!0),t.bindVisibility(e,"mybool",{inverse:!0}),expect(t.is(":visible")).toBe(!1)}),it("When property is changed to false",function(){t.hide(),e.set("mybool",!0),t.bindVisibility(e,"mybool"),e.set("mybool",!1),expect(t.is(":visible")).toBe(!1)}),it("When property is changed to true with inverse=true",function(){expect(t.is(":visible")).toBe(!0),e.set("mybool",!1),t.bindVisibility(e,"mybool",{inverse:!0}),e.set("mybool",!0),expect(t.is(":visible")).toBe(!1)})})})}),suite("djblets/configForms/models/ListItem",function(){describe("Default actions",function(){describe("showRemove",function(){it("true",function(){var e=new Djblets.Config.ListItem({showRemove:!0});expect(e.actions.length).toBe(1),expect(e.actions[0].id).toBe("delete")}),it("false",function(){var e=new Djblets.Config.ListItem({showRemove:!1});expect(e.actions.length).toBe(0)})})})}),suite("djblets/configForms/views/ListItemView",function(){describe("Rendering",function(){describe("Item display",function(){it("With editURL",function(){var e=new Djblets.Config.ListItem({editURL:"http://example.com/",text:"Label"}),t=new Djblets.Config.ListItemView({model:e});t.render(),expect(t.$el.html().strip()).toBe('<span class="config-forms-list-item-actions"></span><a href="http://example.com/">Label</a>')}),it("Without editURL",function(){var e=new Djblets.Config.ListItem({text:"Label"}),t=new Djblets.Config.ListItemView({model:e});t.render(),expect(t.$el.html().strip()).toBe('<span class="config-forms-list-item-actions"></span>Label')})}),describe("Actions",function(){it("Checkboxes",function(){var e=new Djblets.Config.ListItem({text:"Label",checkboxAttr:!1,actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",propName:"checkboxAttr"}]}),t=new Djblets.Config.ListItemView({model:e});t.render(),expect(t.$("input[type=checkbox]").length).toBe(1),expect(t.$("label").length).toBe(1)}),describe("Buttons",function(){it("Simple",function(){var e=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button"}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.render(),n=t.$(".btn"),expect(n.length).toBe(1),expect(n.text()).toBe("Button"),expect(n.hasClass("config-forms-list-action-mybutton")).toBe(!0),expect(n.hasClass("rb-icon")).toBe(!1),expect(n.hasClass("danger")).toBe(!1)}),it("Danger",function(){var e=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button",danger:!0}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.render(),n=t.$(".btn"),expect(n.length).toBe(1),expect(n.text()).toBe("Button"),expect(n.hasClass("config-forms-list-action-mybutton")).toBe(!0),expect(n.hasClass("rb-icon")).toBe(!1),expect(n.hasClass("danger")).toBe(!0)}),it("Icon names",function(){var e=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button",danger:!1,iconName:"foo"}]}),t=new Djblets.Config.ListItemView({model:e}),n,r;t.render(),n=t.$(".btn"),expect(n.length).toBe(1),expect(n.text()).toBe("Button"),expect(n.hasClass("config-forms-list-action-mybutton")).toBe(!0),expect(n.hasClass("danger")).toBe(!1),r=n.find("span"),expect(r.length).toBe(1),expect(r.hasClass("djblets-icon")).toBe(!0),expect(r.hasClass("djblets-icon-foo")).toBe(!0)})}),describe("Menus",function(){var e,t;beforeEach(function(){e=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mymenu",label:"Menu",children:[{id:"mymenuitem",label:"My menu item"}]}]}),t=new Djblets.Config.ListItemView({model:e}),t.render()}),it("Initial display",function(){var e=t.$(".btn");expect(e.length).toBe(1),expect(e.text()).toBe("Menu ▾")}),it("Opening",function(){var e,n;spyOn(_,"defer").andCallFake(function(e){e()}),spyOn(t,"trigger"),e=t.$(".config-forms-list-action-mymenu"),e.click(),n=t.$(".action-menu"),expect(n.length).toBe(1),expect(t.trigger.mostRecentCall.args[0]).toBe("actionMenuPopUp")}),it("Closing",function(){var e,n;spyOn(_,"defer").andCallFake(function(e){e()}),e=t.$(".config-forms-list-action-mymenu"),e.click(),spyOn(t,"trigger"),n=t.$(".action-menu"),$(document.body).click(),expect(t.trigger.mostRecentCall.args[0]).toBe("actionMenuPopDown"),n=t.$(".action-menu"),expect(n.length).toBe(0)})})}),describe("Action properties",function(){describe("enabledPropName",function(){it("value == undefined",function(){var e=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",enabledPropName:"isEnabled"}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.render(),n=t.$(".config-forms-list-action-mycheckbox"),expect(n.prop("disabled")).toBe(!0)}),it("value == true",function(){var e=new Djblets.Config.ListItem({text:"Label",isEnabled:!0,actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",enabledPropName:"isEnabled"}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.render(),n=t.$(".config-forms-list-action-mycheckbox"),expect(n.prop("disabled")).toBe(!1)}),it("value == false",function(){var e=new Djblets.Config.ListItem({text:"Label",isEnabled:!1,actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",enabledPropName:"isEnabled"}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.render(),n=t.$(".config-forms-list-action-mycheckbox"),expect(n.prop("disabled")).toBe(!0)}),describe("with enabledPropInverse == true",function(){it("value == undefined",function(){var e=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",enabledPropName:"isDisabled",enabledPropInverse:!0}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.render(),n=t.$(".config-forms-list-action-mycheckbox"),expect(n.prop("disabled")).toBe(!1)}),it("value == true",function(){var e=new Djblets.Config.ListItem({text:"Label",isDisabled:!0,actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",enabledPropName:"isDisabled",enabledPropInverse:!0}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.render(),n=t.$(".config-forms-list-action-mycheckbox"),expect(n.prop("disabled")).toBe(!0)}),it("value == false",function(){var e=new Djblets.Config.ListItem({text:"Label",isDisabled:!1,actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",enabledPropName:"isDisabled",enabledPropInverse:!0}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.render(),n=t.$(".config-forms-list-action-mycheckbox"),expect(n.prop("disabled")).toBe(!1)})})})})}),describe("Action handlers",function(){it("Buttons",function(){var e=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button"}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.actionHandlers={mybutton:"_onMyButtonClick"},t._onMyButtonClick=function(){},spyOn(t,"_onMyButtonClick"),t.render(),n=t.$(".btn"),expect(n.length).toBe(1),n.click(),expect(t._onMyButtonClick).toHaveBeenCalled()}),it("Checkboxes",function(){var e=new Djblets.Config.ListItem({text:"Label",checkboxAttr:!1,actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",propName:"checkboxAttr"}]}),t=new Djblets.Config.ListItemView({model:e}),n;t.actionHandlers={mybutton:"_onMyButtonClick"},t._onMyButtonClick=function(){},spyOn(t,"_onMyButtonClick"),t.render(),n=t.$("input[type=checkbox]"),expect(n.length).toBe(1),expect(n.prop("checked")).toBe(!1),n.prop("checked",!0).triggerHandler("change"),expect(e.get("checkboxAttr")).toBe(!0)})})}),suite("djblets/configForms/views/ListView",function(){describe("Manages items",function(){var e,t,n;beforeEach(function(){e=new Backbone.Collection([{text:"Item 1"},{text:"Item 2"},{text:"Item 3"}],{model:Djblets.Config.ListItem}),t=new Djblets.Config.List({},{collection:e}),n=new Djblets.Config.ListView({model:t}),n.render()}),it("On render",function(){var e;e=n.$("li"),expect(e.length).toBe(3),expect(e.eq(0).text().strip()).toBe("Item 1"),expect(e.eq(1).text().strip()).toBe("Item 2"),expect(e.eq(2).text().strip()).toBe("Item 3")}),it("On add",function(){var t;e.add({text:"Item 4"}),t=n.$("li"),expect(t.length).toBe(4),expect(t.eq(3).text().strip()).toBe("Item 4")}),it("On remove",function(){var t;e.remove(e.at(0)),t=n.$("li"),expect(t.length).toBe(2),expect(t.eq(0).text().strip()).toBe("Item 2")}),it("On reset",function(){var t;e.reset([{text:"Foo"},{text:"Bar"}]),t=n.$("li"),expect(t.length).toBe(2),expect(t.eq(0).text().strip()).toBe("Foo"),expect(t.eq(1).text().strip()).toBe("Bar")})})}),suite("djblets/configForms/views/TableItemView",function(){describe("Rendering",function(){describe("Item display",function(){it("With editURL",function(){var e=new Djblets.Config.ListItem({editURL:"http://example.com/",text:"Label"}),t=new Djblets.Config.TableItemView({model:e});t.render(),expect(t.$el.html().strip()).toBe('<td><span class="config-forms-list-item-actions"></span><a href="http://example.com/">Label</a></td>')}),it("Without editURL",function(){var e=new Djblets.Config.ListItem({text:"Label"}),t=new Djblets.Config.TableItemView({model:e});t.render(),expect(t.$el.html().strip()).toBe('<td><span class="config-forms-list-item-actions"></span>Label</td>')})}),describe("Action placement",function(){it("Default template",function(){var e=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button"}]}),t=new Djblets.Config.TableItemView({model:e}),n;t.render(),n=t.$("td:last .btn"),expect(n.length).toBe(1),expect(n.text()).toBe("Button")}),it("Custom template",function(){var e=Djblets.Config.TableItemView.extend({template:_.template(["<td></td>","<td></td>"].join(""))}),t=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button"}]}),n=new e({model:t}),r;n.render(),r=n.$("td:last .btn"),expect(r.length).toBe(1),expect(r.text()).toBe("Button")})})})}),suite("djblets/configForms/views/TableView",function(){describe("Manages rows",function(){var e,t,n;beforeEach(function(){e=new Backbone.Collection([{text:"Item 1"},{text:"Item 2"},{text:"Item 3"}],{model:Djblets.Config.ListItem}),t=new Djblets.Config.List({},{collection:e}),n=new Djblets.Config.TableView({model:t}),n.render()}),it("On render",function(){var e;e=n.$("tr"),expect(e.length).toBe(3),expect(e.eq(0).text().strip()).toBe("Item 1"),expect(e.eq(1).text().strip()).toBe("Item 2"),expect(e.eq(2).text().strip()).toBe("Item 3")}),it("On add",function(){var t;e.add({text:"Item 4"}),t=n.$("tr"),expect(t.length).toBe(4),expect(t.eq(3).text().strip()).toBe("Item 4")}),it("On remove",function(){var t;e.remove(e.at(0)),t=n.$("tr"),expect(t.length).toBe(2),expect(t.eq(0).text().strip()).toBe("Item 2")}),it("On reset",function(){var t;e.reset([{text:"Foo"},{text:"Bar"}]),t=n.$("tr"),expect(t.length).toBe(2),expect(t.eq(0).text().strip()).toBe("Foo"),expect(t.eq(1).text().strip()).toBe("Bar")})})})}).call(this);